// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'ExtraFileUtils.pas' rev: 6.00

#ifndef ExtraFileUtilsHPP
#define ExtraFileUtilsHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <SyncObjs.hpp>	// Pascal unit
#include <ExtraFunctions.hpp>	// Pascal unit
#include <StrUtils.hpp>	// Pascal unit
#include <CodeFromLCL.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Extrafileutils
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS IOException;
class PASCALIMPLEMENTATION IOException : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	#pragma option push -w-inl
	/* Exception.Create */ inline __fastcall IOException(const AnsiString Msg) : Sysutils::Exception(Msg) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall IOException(const AnsiString Msg, const System::TVarRec * Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall IOException(int Ident)/* overload */ : Sysutils::Exception(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall IOException(int Ident, const System::TVarRec * Args, const int Args_Size)/* overload */ : Sysutils::Exception(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall IOException(const AnsiString Msg, int AHelpContext) : Sysutils::Exception(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall IOException(const AnsiString Msg, const System::TVarRec * Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall IOException(int Ident, int AHelpContext)/* overload */ : Sysutils::Exception(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall IOException(System::PResStringRec ResStringRec, const System::TVarRec * Args, const int Args_Size, int AHelpContext)/* overload */ : Sysutils::Exception(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~IOException(void) { }
	#pragma option pop
	
};


typedef void __fastcall (__closure *TCopyFileProgressCallback)(const __int64 current, const __int64 total);

typedef void __fastcall (__closure *TCopyFileFinishCallback)(const bool resultt);

class DELPHICLASS TCopyFileThread;
class PASCALIMPLEMENTATION TCopyFileThread : public Classes::TThread 
{
	typedef Classes::TThread inherited;
	
private:
	Syncobjs::TCriticalSection* curLock;
	Syncobjs::TCriticalSection* totalLock;
	__int64 _current;
	__int64 _total;
	
protected:
	virtual void __fastcall Execute(void);
	__int64 __fastcall GetTotal(void);
	void __fastcall SetTotal(const __int64 value);
	__int64 __fastcall GetCurrent(void);
	void __fastcall SetCurrent(const __int64 value);
	
public:
	bool CopyResult;
	TCopyFileProgressCallback CopyFileProgress;
	TCopyFileFinishCallback CopyFileFinish;
	AnsiString SourceFilePath;
	AnsiString DestFilePath;
	bool OverwriteExists;
	__property __int64 Total = {read=GetTotal};
	__property __int64 Current = {read=GetCurrent};
	__fastcall TCopyFileThread(const AnsiString source, const AnsiString dest, const bool overwriteExists, const bool startSuspended);
	__fastcall virtual ~TCopyFileThread(void);
};


class DELPHICLASS TFileSystemElemInfo;
class PASCALIMPLEMENTATION TFileSystemElemInfo : public System::TObject 
{
	typedef System::TObject inherited;
	
protected:
	Sysutils::TSearchRec SearchRec;
	
public:
	AnsiString FullPath;
	__fastcall virtual TFileSystemElemInfo(const AnsiString filePath)/* overload */;
	__fastcall virtual TFileSystemElemInfo(const AnsiString filePath, const Sysutils::TSearchRec &searchInfo)/* overload */;
	virtual AnsiString __fastcall Name();
	virtual int __fastcall Attributes(void);
	virtual bool __fastcall Exists(void) = 0 ;
	virtual bool __fastcall CopyTo(const AnsiString path, const bool overwriteExists = false) = 0 ;
	virtual bool __fastcall Delete(void) = 0 ;
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TFileSystemElemInfo(void) { }
	#pragma option pop
	
};


class DELPHICLASS TFileInfo;
class PASCALIMPLEMENTATION TFileInfo : public TFileSystemElemInfo 
{
	typedef TFileSystemElemInfo inherited;
	
public:
	virtual bool __fastcall CopyTo(const AnsiString path, const bool overwriteExists = false);
	virtual bool __fastcall Delete(void);
	virtual bool __fastcall Exists(void);
public:
	#pragma option push -w-inl
	/* TFileSystemElemInfo.Create */ inline __fastcall virtual TFileInfo(const AnsiString filePath)/* overload */ : TFileSystemElemInfo(filePath) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TFileInfo(void) { }
	#pragma option pop
	
};


class DELPHICLASS TDirectoryInfo;
class DELPHICLASS TFileSystemIterator;
class PASCALIMPLEMENTATION TDirectoryInfo : public TFileSystemElemInfo 
{
	typedef TFileSystemElemInfo inherited;
	
public:
	virtual bool __fastcall CopyTo(const AnsiString path, const bool overwriteExists = false);
	virtual bool __fastcall Delete(void);
	virtual bool __fastcall Exists(void);
	TFileSystemIterator* __fastcall GetFiles(void)/* overload */;
	TFileSystemIterator* __fastcall GetFiles(const AnsiString mask)/* overload */;
	TFileSystemIterator* __fastcall GetDirectories(void)/* overload */;
	TFileSystemIterator* __fastcall GetDirectories(const AnsiString mask)/* overload */;
public:
	#pragma option push -w-inl
	/* TFileSystemElemInfo.Create */ inline __fastcall virtual TDirectoryInfo(const AnsiString filePath)/* overload */ : TFileSystemElemInfo(filePath) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TDirectoryInfo(void) { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TFileSystemIterator : public System::TObject 
{
	typedef System::TObject inherited;
	
protected:
	Sysutils::TSearchRec searchInfo;
	AnsiString folder;
	
public:
	TFileSystemElemInfo* Current;
	int SearchAttr;
	__fastcall TFileSystemIterator(const AnsiString folderPath, const bool onlyFiles)/* overload */;
	__fastcall TFileSystemIterator(const AnsiString folderPath, const int attrPredicat)/* overload */;
	__fastcall TFileSystemIterator(const AnsiString folderPath, const AnsiString searchMask, const bool onlyFiles)/* overload */;
	__fastcall TFileSystemIterator(const AnsiString folderPath, const AnsiString searchMask, const int attrPredicat)/* overload */;
	__fastcall virtual ~TFileSystemIterator(void);
	bool __fastcall Next(void);
};


class DELPHICLASS TTempFolder;
class PASCALIMPLEMENTATION TTempFolder : public System::TObject 
{
	typedef System::TObject inherited;
	
protected:
	AnsiString path;
	AnsiString name;
	
public:
	__fastcall TTempFolder(const AnsiString subName);
	__fastcall virtual ~TTempFolder(void);
	AnsiString __fastcall GetTempPath();
};


//-- var, const, procedure ---------------------------------------------------
static const int FILECOPY_BUFFER_SIZE = 0x14000;
extern PACKAGE int INVALID_SYSFILE_ATTR;
static const Shortint resOk = 0x0;
static const Shortint resParametersError = 0x1;
extern PACKAGE bool __fastcall CopyDirectory(const AnsiString sourceDir, const AnsiString destDir, const bool overwriteExists = false, const bool recursive = true);
extern PACKAGE Classes::TThread* __fastcall AsyncCopyFileEx(const AnsiString sourcePath, const AnsiString destPath, const TCopyFileFinishCallback onFinish, const TCopyFileProgressCallback onProgress, const bool overwriteExists = false);
extern PACKAGE Classes::TThread* __fastcall AsyncCopyFile(const AnsiString sourcePath, const AnsiString destPath, const TCopyFileFinishCallback onFinish, const bool overwriteExists = false);
extern PACKAGE bool __fastcall FileSystemElemExists(const AnsiString path);
extern PACKAGE bool __fastcall IsDirectory(const AnsiString path)/* overload */;
extern PACKAGE bool __fastcall IsDirectory(const int attr)/* overload */;
extern PACKAGE bool __fastcall IsLocalPath(const AnsiString PathStr);
extern PACKAGE bool __fastcall IsGlobalPath(const AnsiString PathStr);
extern PACKAGE AnsiString __fastcall FixLocalPath(const AnsiString PathStr);
extern PACKAGE AnsiString __fastcall ResolveLocalPath(const AnsiString LocalPath, const AnsiString GlobalPath);
extern PACKAGE AnsiString __fastcall GetLocalPath(const AnsiString GlobalRoot, const AnsiString FullPath);
extern PACKAGE __int64 __fastcall GetFileSize(const AnsiString FileName);
extern PACKAGE int __fastcall GetFilesNumber(const AnsiString DirName, const bool Recursive);
extern PACKAGE bool __fastcall IsDirsChild(const AnsiString DirName, const AnsiString ChildName);
extern PACKAGE AnsiString __fastcall AddExtensionIfAbsent(const AnsiString path, const AnsiString extension);
extern PACKAGE AnsiString __fastcall GetFileNameWithoutExtension(const AnsiString path);
extern PACKAGE bool __fastcall HasLastSlash(const AnsiString Str);
extern PACKAGE AnsiString __fastcall AddLastSlash(const AnsiString str);
extern PACKAGE AnsiString __fastcall DelLastSlash(const AnsiString Str);

}	/* namespace Extrafileutils */
using namespace Extrafileutils;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// ExtraFileUtils
